/*
 * Created on 2020-01-20 ( Time 17:38:37 )
 * Generated by Telosys Tools Generator ( version 3.1.2 )
 */
// This Bean has a basic Primary Key (not composite) 

package ci.salaamsolutions.projet.spasuce.dao.entity;

import java.io.Serializable;

//import javax.validation.constraints.* ;
//import org.hibernate.validator.constraints.* ;

import java.util.Date;
import java.util.List;

import javax.persistence.*;

import lombok.*;

/**
 * Persistent class for entity stored in table "user"
 *
* @author Back-End developper
   *
 */

@Entity
@Table(name="user" )
@Data // getters setters
@AllArgsConstructor // constructeur avec arguments
@NoArgsConstructor // constructeur sans arguments
public class User implements Serializable, Cloneable {

    private static final long serialVersionUID = 1L;

    //----------------------------------------------------------------------
    // ENTITY PRIMARY KEY ( BASED ON A SINGLE FIELD )
    //----------------------------------------------------------------------
	/*
	 * 
	 */
    @Id
    @GeneratedValue(strategy=GenerationType.AUTO)
    @Column(name="id", nullable=false)
    private Integer    id           ;


    //----------------------------------------------------------------------
    // ENTITY DATA FIELDS 
    //----------------------------------------------------------------------    
	/*
	 * 
	 */
    @Column(name="nom", length=255)
    private String     nom          ;

	/*
	 * 
	 */
    @Column(name="prenoms", length=255)
    private String     prenoms      ;

	/*
	 * 
	 */
    @Column(name="login", length=255)
    private String     login        ;

	/*
	 * 
	 */
    @Column(name="password", length=255)
    private String     password     ;

	/*
	 * 
	 */
    @Column(name="telephone", length=255)
    private String     telephone    ;

	/*
	 * 
	 */
    @Column(name="email", length=255)
    private String     email        ;

	/*
	 * 
	 */
    @Column(name="is_locked")
    private Boolean    isLocked     ;

	/*
	 * 
	 */
    @Column(name="is_su_user")
    private Boolean    isSuUser     ;

	/*
	 * Valeur a setter si les inscription suivent un procès
	 */
    @Column(name="is_valider")
    private Boolean    isValider    ;

	/*
	 * 
	 */
    @Column(name="token", length=255)
    private String     token        ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="date_expiration_token")
    private Date       dateExpirationToken ;

	/*
	 * 
	 */
    @Column(name="is_token_valide")
    private Boolean    isTokenValide ;

	/*
	 * 
	 */
    @Column(name="created_by")
    private Integer    createdBy    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="created_at")
    private Date       createdAt    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="updated_at")
    private Date       updatedAt    ;

	/*
	 * 
	 */
    @Column(name="updated_by")
    private Integer    updatedBy    ;

	/*
	 * 
	 */
    @Temporal(TemporalType.TIMESTAMP)
    @Column(name="deleted_at")
    private Date       deletedAt    ;

	/*
	 * 
	 */
    @Column(name="deleted_by")
    private Integer    deletedBy    ;

	/*
	 * 
	 */
    @Column(name="is_deleted")
    private Boolean    isDeleted    ;

	// "roleId" (column "role_id") is not defined by itself because used as FK in a link 
	// "entrepriseId" (column "entreprise_id") is not defined by itself because used as FK in a link 


    //----------------------------------------------------------------------
    // ENTITY LINKS ( RELATIONSHIP )
    //----------------------------------------------------------------------
    @ManyToOne
    @JoinColumn(name="role_id", referencedColumnName="id")
        private Role role;
    @ManyToOne
    @JoinColumn(name="entreprise_id", referencedColumnName="id")
        private Entreprise entreprise;

	//----------------------------------------------------------------------
    // clone METHOD
    //----------------------------------------------------------------------
	@Override
	public Object clone() throws CloneNotSupportedException {
		return super.clone();
	}
}
